package com.jforeach.mazegame;

import java.util.Random;

import com.jforeach.mazegame.R;

import android.R.string;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.Typeface;
import android.util.Log;
import android.view.Display;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

public class GameView extends View {
	
	//width and height of the whole maze and width of lines which
	//make the walls
	private int width, height, lineWidth;
	//size of the maze i.e. number of cells in it
	private int mazeSizeX, mazeSizeY;
	//width and height of cells in the maze
	float cellWidth, cellHeight;
	//the following store result of cellWidth+lineWidth 
	//and cellHeight+lineWidth respectively 
	float totalCellWidth, totalCellHeight;
	//the finishing point of the maze
	private int mazeFinishX, mazeFinishY;
	private Maze maze;
	private Activity context;
	private Paint line, red, background;
	
	int currentX = 20, currentY = 150;
	int ballVelX = 4, ballVelY = 5;
	int star = 0, speedUp = 1, i = 0;
	int screenWidth = 450;
	int lineStartX = 150, lineEndX = 330;
	int compLine1StartX = 50, compLine1EndX = 200;
	int compLine2StartX = 275, compLine2EndX = 425;
	int starX = 60, starY = 250;
	//int speedUpX = 150, speedUpY = 80;
	int playerPoints = 0, computerPoints = 0;
	
	// moving the paddle	
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		//event.getAction();
		if ((event.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_DPAD_LEFT)){
			if(lineStartX >= 5){
				lineStartX = lineStartX - 5; lineEndX = lineEndX - 5;
			}
		}
		if ((event.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT)){
			if(lineEndX <= 475){
				lineStartX = lineStartX + 5; lineEndX = lineEndX + 5;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	
	
	

	
	
	public GameView(Context context, Maze maze) {
		super(context);
		this.context = (Activity)context;
		this.maze = maze;
		mazeFinishX = maze.getFinalX();
		mazeFinishY = maze.getFinalY();
		mazeSizeX = maze.getMazeWidth();
		mazeSizeY = maze.getMazeHeight();
		line = new Paint();
		//line.setColor(getResources().getColor(R.color.line));
		line.setColor(getResources().getColor(R.color.game_bg));
		red = new Paint();
		red.setColor(getResources().getColor(R.color.position));
		background = new Paint();
		//background.setColor(getResources().getColor(R.color.game_bg));
		//background.setColor(getResources().getColor(R.color.game_bg));
		setFocusable(true);
		//this.setFocusableInTouchMode(true);
		
		
		/*
		 * 
		 * Blah
		 * 
		 * Display display = getWindowToken().getDefaultDisplay();
		Point size = new Point();
		display.getSize(size);
		int screenWidth = size.x;
		int screenheight = size.y;*/
		//currentX = currentX+1;
	}
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		width = (w < h)?w:h;
		height = width;         //for now square mazes
		lineWidth = 5;          //for now 1 pixel wide walls
		cellWidth = (width - ((float)mazeSizeX*lineWidth)) / mazeSizeX;
		totalCellWidth = cellWidth+lineWidth;
		cellHeight = (height - ((float)mazeSizeY*lineWidth)) / mazeSizeY;
		totalCellHeight = cellHeight+lineWidth;
		//red.setTextSize(cellHeight*0.75f);
		super.onSizeChanged(w, h, oldw, oldh);
	}
	
	
	
	

   
	
	protected void onDraw(Canvas canvas) {
		//fill in the background
		//canvas.drawRect(0, 0, width, height, background);
		
		canvas.drawLine(0, 2, 479, 2, line);
		canvas.drawLine(0, 480, 480, 480, line);
		canvas.drawLine(0, 2, 0, 480, line);
		canvas.drawLine(479, 2, 479, 480, line);
		
		//computer paddle
	
		canvas.drawLine(compLine1StartX, 20, compLine1EndX, 20, line);
		canvas.drawLine(compLine2StartX, 20, compLine2EndX, 20, line);
		
		//bottom paddle
		
		canvas.drawLine(lineStartX, 450, lineEndX, 450, line);
		
		//ball movement control
		
		currentX = currentX + ballVelX;
		currentY = currentY + ballVelY;
		
		if(currentX <= 0){
			ballVelX = ballVelX *-1;
			i += 1;
		}
		
		if(currentY <= 0 | currentY == 20 & ((currentX >= compLine1StartX & currentX <= compLine1EndX) | (currentX >= compLine2StartX & currentX <= compLine2EndX))){
			if(ballVelY<0){
				ballVelY = ballVelY *-1;
			}
			//yay! point!
			if(currentY <= 0){
				playerPoints += 1;
				i = 0;
			}
		}
		
		if(currentX >= 480){
			ballVelX = ballVelX *-1;
			i += 1;
		}
		
		if(currentY >= 480 | (currentY == 450 & (currentX >= lineStartX & currentX <= lineEndX))){
			if(ballVelY>0){
				ballVelY = ballVelY *-1;
				
			}
			if(currentY >= 480){
				computerPoints += 1;
				// star random frequence
				if(i >= 2){
					star = 1;
				}
			}
		}
		
		// hit the star
		if(star == 1 & (currentY >= starY & currentY <= (starY + 20)) & (currentX >= starX & (currentX <= starX + 20))){
			if(ballVelY<0){
				playerPoints += 3;
				star = 0;
			}
			else if(ballVelY>0){
				computerPoints += 3;
				star = 0;
			}
		}
		/*
		if(speedUp == 1 & (currentY >= speedUpY & currentY <= (speedUpY + 20)) & (currentX >= speedUpX & (currentX <= speedUpX + 20))){
			if(ballVelY<0){
				ballVelX += 5;
				ballVelY += 5;
				
			}
			
		}*/
		
		
		//draw the ball
		
		canvas.drawCircle(currentX,   //x of center
				  currentY,  //y of center
				  5,                           //radius
				  red);
	
		
		
		// draw star	
		if(star==1){	
			canvas.drawBitmap(BitmapFactory.decodeResource(getResources(), R.drawable.star), starX, starY, null);
		}
		/*	 draw speedup
		if(speedUp==1){	
			canvas.drawBitmap(BitmapFactory.decodeResource(getResources(), R.drawable.arrowup), starX, starY, null);
		}
			*/
			
			/*###############
			 * 
			 * Point system:
			 * 
			 ###############*/
			
			canvas.drawText("Computer",
					10,	185, red);
			canvas.drawText("Player",
					10,	235, red);
			
			String cPoints = Integer.toString(computerPoints);
						
			canvas.drawText(cPoints, 10,	200, red);
			
			//playerPoints 
			String pPoints = Integer.toString(playerPoints);
			
			canvas.drawText(pPoints, 10,	250, red);
			
		

			invalidate();
			
			
	}
	
}
